// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Fx_core.pas' rev: 20.00

#ifndef Fx_coreHPP
#define Fx_coreHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Fx_version.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Fx_core
{
//-- type declarations -------------------------------------------------------
#pragma pack(push,1)
struct TfxColor
{
	
	union
	{
		struct 
		{
			System::Byte R;
			System::Byte G;
			System::Byte B;
			System::Byte A;
			
		};
		struct 
		{
			System::Word HiWord;
			System::Word LoWord;
			
		};
		struct 
		{
			unsigned Color;
			
		};
		
	};
};
#pragma pack(pop)


typedef TfxColor *PfxColor;

typedef StaticArray<TfxColor, 65536> TfxColorArray;

typedef TfxColorArray *PfxColorArray;

#pragma pack(push,1)
struct TfxPoint
{
	
public:
	float x;
	float y;
};
#pragma pack(pop)


class DELPHICLASS TfxAdapter;
class PASCALIMPLEMENTATION TfxAdapter : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	__classmethod bool __fastcall Support(System::TObject* AObject) = 0 ;
	__classmethod System::TObject* __fastcall Create(int Width, int Height) = 0 ;
	__classmethod int __fastcall GetWidth(System::TObject* AObject) = 0 ;
	__classmethod int __fastcall GetHeight(System::TObject* AObject) = 0 ;
	__classmethod void * __fastcall GetScanline(System::TObject* AObject, int Line) = 0 ;
	__classmethod virtual void * __fastcall GetStartLine(System::TObject* AObject);
	__classmethod virtual void __fastcall BeginUpdate(System::TObject* AObject);
	__classmethod virtual void __fastcall EndUpdate(System::TObject* AObject);
	__classmethod void __fastcall SetSize(System::TObject* AObject, const int AWidth, const int AHeight) = 0 ;
public:
	/* TObject.Create */ inline __fastcall TfxAdapter(void) : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TfxAdapter(void) { }
	
};


typedef TMetaClass* TfxAdapterClass;

#pragma option push -b-
enum TfxValueType { feValueFloat, feValuePoint, feValueColor, feValueBitmap };
#pragma option pop

struct TfxValueRec
{
	
public:
	System::UnicodeString Name;
	System::UnicodeString Desc;
	TfxValueType ValueType;
	System::Variant Value;
	System::Variant Min;
	System::Variant Max;
	System::Variant Default;
};


typedef DynamicArray<TfxValueRec> TfxValueRecArray;

struct TfxFilterRec
{
	
public:
	System::UnicodeString Name;
	System::UnicodeString Desc;
	TfxValueRecArray Values;
};


class DELPHICLASS TfxFilter;
class PASCALIMPLEMENTATION TfxFilter : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
public:
	System::Variant operator[](System::UnicodeString Index) { return Values[Index]; }
	
private:
	System::Variant __fastcall GetValues(System::UnicodeString Index);
	void __fastcall SetValues(System::UnicodeString Index, const System::Variant &Value);
	System::TObject* __fastcall GetValuesAsBitmap(System::UnicodeString Index);
	void __fastcall SetValuesAsBitmap(System::UnicodeString Index, const System::TObject* Value);
	TfxPoint __fastcall GetValuesAsPoint(System::UnicodeString Index);
	void __fastcall SetValuesAsPoint(System::UnicodeString Index, const TfxPoint &Value);
	void __fastcall SetInputFilter(const TfxFilter* Value);
	
protected:
	TfxValueRecArray FValues;
	System::TObject* FInput;
	System::TObject* FTarget;
	System::TObject* FOutput;
	bool FProcessing;
	bool FModified;
	TfxFilter* FInputFilter;
	
public:
	__fastcall virtual TfxFilter(void);
	__fastcall virtual ~TfxFilter(void);
	__classmethod TfxFilterRec __fastcall FilterAttr() = 0 ;
	virtual void __fastcall Apply(void) = 0 ;
	__property System::Variant Values[System::UnicodeString Index] = {read=GetValues, write=SetValues/*, default*/};
	__property System::TObject* ValuesAsBitmap[System::UnicodeString Index] = {read=GetValuesAsBitmap, write=SetValuesAsBitmap};
	__property TfxPoint ValuesAsPoint[System::UnicodeString Index] = {read=GetValuesAsPoint, write=SetValuesAsPoint};
	__property TfxFilter* InputFilter = {read=FInputFilter, write=SetInputFilter};
};


typedef TMetaClass* TfxFilterClass;

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Classes::TStrings* Filters;
extern PACKAGE Classes::TList* Adapters;
extern PACKAGE TfxPoint __fastcall fxPoint(float x, float y);
extern PACKAGE bool __fastcall VarIsPoint(const System::Variant &V);
extern PACKAGE System::Variant __fastcall VarFromPointXY(float x, float y);
extern PACKAGE System::Variant __fastcall VarFromPoint(const TfxPoint &P);
extern PACKAGE TfxPoint __fastcall VarToPoint(const System::Variant &V);
extern PACKAGE float __fastcall VarToPointX(const System::Variant &V);
extern PACKAGE float __fastcall VarToPointY(const System::Variant &V);
extern PACKAGE bool __fastcall VarIsObject(const System::Variant &V);
extern PACKAGE System::Variant __fastcall VarFromObject(System::TObject* AObject);
extern PACKAGE System::TObject* __fastcall VarToObject(const System::Variant &V);
extern PACKAGE System::TObject* __fastcall fxCreateObject(System::TObject* AObject, int Width, int Height);
extern PACKAGE int __fastcall fxGetWidth(System::TObject* AObject);
extern PACKAGE int __fastcall fxGetHeight(System::TObject* AObject);
extern PACKAGE void __fastcall fxSetSize(System::TObject* AObject, const int AWidth, const int AHeight);
extern PACKAGE void __fastcall RegisterAdapter(TfxAdapterClass Adapter);
extern PACKAGE void __fastcall UnregisterAdapter(TfxAdapterClass Adapter);
extern PACKAGE TfxAdapterClass __fastcall FindAdapter(System::TObject* AObject);
extern PACKAGE TfxFilter* __fastcall FilterByName(System::UnicodeString AName);
extern PACKAGE TfxFilterClass __fastcall FilterClassByName(System::UnicodeString AName);
extern PACKAGE void __fastcall RegisterFilter(System::UnicodeString Category, TfxFilterClass Filter);
extern PACKAGE void __fastcall FillCategory(Classes::TStrings* AList);
extern PACKAGE void __fastcall FillFiltersInCategory(System::UnicodeString Category, Classes::TStrings* AList);
extern PACKAGE TfxFilterRec __fastcall FilterRec(System::UnicodeString AName, System::UnicodeString ADesc, TfxValueRec *AValues, const int AValues_Size);
extern PACKAGE TfxValueRec __fastcall FilterValueRec(System::UnicodeString AName, System::UnicodeString ADesc, TfxValueType AType, const System::Variant &ADefault, const System::Variant &AMin, const System::Variant &AMax);

}	/* namespace Fx_core */
using namespace Fx_core;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Fx_coreHPP
